
#include <FL/Fl.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Pack.H>
#include <FL/Fl_Scroll.H>


int main( int argc, const char* argv[] )
{
    Fl_Double_Window win( 640, 480 );
    win.begin();
    Fl_Group grp( 0, 0, 640, 600 );
    grp.begin();
        
    Fl_Scroll scroll( 0, 21, 640, 500 ); // notice 500 goes outside window h
    scroll.type( Fl_Scroll::VERTICAL );
    scroll.begin();
    Fl_Pack   pack( 0, 21, 640, 600 );
    pack.type( Fl_Pack::VERTICAL );
    pack.begin();
    
    char buf[256];
    for ( int i = 0; i < 16; ++i )
    {
        sprintf( buf, "Button #%d\nSecond row\nThird row", i );
        Fl_Button* b = new Fl_Button( 0, 20+i * 70, 640, 70 );
        b->copy_label( buf );
        b->align( FL_ALIGN_INSIDE | FL_ALIGN_CENTER );
    }
    pack.end();
    scroll.end();
    grp.end();
    win.end();
    win.show();
    return Fl::run();
}
